% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/wkt.R, R/crs.R
\name{st_as_text}
\alias{st_as_text}
\alias{st_as_text.crs}
\alias{st_as_text.sfc}
\alias{st_as_text.sfg}
\title{Return Well-known Text representation of simple feature geometry or coordinate reference system}
\usage{
st_as_text(x, ...)

\method{st_as_text}{sfg}(x, ...)

\method{st_as_text}{sfc}(x, ..., EWKT = FALSE)

\method{st_as_text}{crs}(x, ..., pretty = FALSE)
}
\arguments{
\item{x}{object of class \code{sfg}, \code{sfc} or \code{crs}}

\item{...}{passed on to WKT_name}

\item{EWKT}{logical; if TRUE, print SRID=xxx; before the WKT string if epsg is available}

\item{pretty}{logical; if TRUE, print human-readable well-known-text representation of a coordinate reference system}
}
\description{
Return Well-known Text representation of simple feature geometry or coordinate reference system
}
\details{
to suppress printing of SRID, \code{EWKT=FALSE} can be passed as parameter
}
\examples{
st_as_text(st_point(1:2))
}

